<html lang="en">
<head>
<title>Naming Conventions - Enhanced Implementation of Emacs Interpreted Objects</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Enhanced Implementation of Emacs Interpreted Objects">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="prev" href="Documentation.html#Documentation" title="Documentation">
<link rel="next" href="Demo-Programs.html#Demo-Programs" title="Demo Programs">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Naming-Conventions"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Demo-Programs.html#Demo-Programs">Demo Programs</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="Documentation.html#Documentation">Documentation</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="index.html#Top">Top</a>
<hr>
</div>

<!-- node-name,  next,  previous,  up -->
<h2 class="chapter">17 Naming Conventions</h2>

<p>The Emacs Lisp programming manual has a great chapter programming
conventions that help keep each Emacs package working nicely with the
entire system.  <a href="../elisp/Standards.html#g_t_0028elisp_0029Standards">(elisp)Standards</a> An EIEIO based program needs to
follow these conventions, while simultaneously taking advantage of the
Object Oriented features.

   <p>The below tips are things that I do when I program an EIEIO based
package.

     <ul>
<li>Come up with a package prefix that is relatively short.  Prefix
all classes, and methods with your prefix.  This is a standard
convention for functions and variables in Emacs. 
<li>Do not prefix method names with the class name.  All methods in
EIEIO are &ldquo;virtual&rdquo;, and are dynamically dispatched.  Anyone can
override your methods at any time.  Your methods should be prefixed
with your package name. 
<li>Do not prefix slots in your class.  The slots are always locally
scoped to your class, and need no prefixing. 
<li>If your library inherits from other libraries of classes, you
must &ldquo;require&rdquo; that library with the <code>require</code> command. 
</ul>

   </body></html>

